apckmat <-
function(a, p, p0=1, k=1) {
## matrix for APC model with single row but k-multiple columns
## for each cohort allowing first p0 columns to be incomplete cohort. 
## The last columns can also be incomplete cohorts. see Fu (2018)
	alpha <- rbind(diag(rep(1, a - 1)), rep(-1, a - 1))
	beta  <- rbind(diag(rep(1, p - 1)), rep(-1, p - 1))
##	gamma <- rbind(diag(rep(1, a + p - 2)), rep(-1, a + p - 2))

## ?	n.gamma <- a + ceiling (((p-1) - p0 ) / k ) 
	
	if (p0 > 0) 
		n.gamma <- a + ceiling ((p - p0)/k )
	if (p0 == 0)
		n.gamma <- a - 1 + ceiling ((p - p0)/k ) 

###	create an index matrix
	coh.ind <-  matrix(0, a, p)
	for (i in 1:a)	{
		if (p0 > 0) {     ## p0 > 0
			coh.ind [i, 1:p0] <- a-i+1
			for (j in 1:p)
				coh.ind[i, j] <- a - i + (ceiling( (j-p0)/k ) + 1)
		 }   ## p0 > 0
		if ( p0 == 0 )  {
			for (j in 1:p)
				coh.ind[i, j] <- a - i + (ceiling( (j-p0)/k ) )
	
		 }
	}
	coh.max = max(coh.ind)
# browser()
### 	convert cohort index into gamm matrix for cohort 
	gamm <- matrix(0,a*p, n.gamma-1)
	for (i in 1:a)
		for (j in 1:p) {
			if (coh.ind[i,j] < coh.max )
				gamm[(i-1)*p+j, coh.ind[i,j] ] = 1
			if (coh.ind[i,j] == coh.max )
				gamm[(i-1)*p+j, ] = -1
		}

	x <- rep(0, a+p-1)
	for(i in 1:a) {
		for(j in 1:p) {
			rr <- c(1, alpha[i,  ], beta[j,  ])
			x <- rbind(x, rr)
		}
	}
	x <- x[-1,  ]
	x <- cbind(x, gamm)
	x
}
