apclinkfit_run <-
function(r, c1 = 1, c2 = 1, cc = 1, apc = 0, lambda = 0, gamma = 2,  Plot = F, CIplot=T, 
     transform = "log", panelplot = T, amin=1, pmin=1, cmin=1, agapyr = 1, pgapyr = 1, cgapyr = 1, p0=0, 
     k=1, header = F, resid.out = F, ModelDiag = F, Diaglim = c (0,0), Diag.na = c(0,0), pplim = c(0,0)) {
  #########################################################
  #### header for the labels of age, period and cohort plot
  
  if (header == T) {
    age = floor(as.numeric(dimnames(r)[[1]]))
    period = floor(as.numeric(dimnames(r)[[2]]))
    cohort0 = period[1] - age[length(age)] 

    if (age[2] - age[1] != age[3] - age[2]) ### incomplete first age group
      age[1] = 2*age [2] - age[3]
    if (period[2] - period[1] != period[3] - period[2])   ### incomplete first period group
      period[1] = 2*period[2] - period[3]
  }  
  
  a <- nrow(r)
  p <- ncol(r)
  
  if (transform == "log")
    r = log(r)
  
  y <- c(t(r))
  x <- apckmat(a, p, p0=p0, k=k)
  n.coh = ncol(x) - a - p + 2
  
  if (cmin > 1000)
    cohort0 = cmin
  cohort = cohort0 + (1:n.coh-1)*(age[3]-age[2])
  
  if (header == F){
    age = amin + agapyr *(1:a-1)
    period = pmin + pgapyr * (1:p-1)
    cohort = cmin + cgapyr * (1:(ncol(x)-a-p+1))
  }
  
  ##########################################################
  #### Model fitting #### Intrinsic estimator ##############
  if(apc == 0) {
    v <- eigen(t(x) %*% x)$vector
    xx <- x %*% v[,  - (ncol(v))]
    
    if  (prod(Diag.na) > 0) {
      if (length(as.vector(Diag.na)) == 2)
        r[Diag.na[1], Diag.na[2]] = -Inf
      else 
        for (i in 1:(length(as.vector(Diag.na))/2))
          r[Diag.na[i,1], Diag.na[i,2]] = -Inf
    }

    r = as.vector(t(r)) ;     r.na = (r==-Inf);     y = r[!r.na]
    x.no.na = xx[!r.na,]
    xx = x.no.na
    
    fit <- lm(y ~ xx-1)
    b <- as.vector(v %*% as.matrix(c(fit$coef, 0)))
    aa <- b[1:(a - 1) + 1]
    pp <- b[2:p + a - 1]
    coh <- b[ - 1:-(a + p - 1)]
    n.coh = length(coh) + 1

    bvar.red <- diag(summary.lm(fit)$coef[,2]) %*% 
      summary.lm(fit,corr=T)$corr %*% diag(
        summary.lm(fit)$coef[,2])
    bvar <- v%*%(cbind(rbind(bvar.red,0),0))%*%t(v)

    alast.se <- sqrt( t(as.matrix(rep(-1, a-1)))%*%bvar[2:a,2:a]%*%as.matrix(rep(-1, a-1)) )
    plast.se <- sqrt( t(as.matrix(rep(-1, p-1)))%*%bvar[2:p-1+a,2:p-1+a]%*%as.matrix(rep(-1, p-1)) )
    clast.se <- sqrt( t(as.matrix(rep(-1, n.coh-1)))%*%bvar[-1:-(p-1+a),-1:-(p-1+a)]%*%as.matrix(rep(-1, n.coh-1)) )
    b.para <- cbind(c(b[1], aa, -sum(aa), pp, -sum(pp), coh, -sum(coh)), 
                    c(sqrt(diag(bvar[1:a,1:a])), alast.se, sqrt(diag(bvar[2:p+a-1,2:p+a-1])), plast.se, 
                      sqrt(diag(bvar[-1:-(a+p-1),-1:-(a+p-1)])), clast.se) )
    b.para.full = cbind(b.para, Tval <- b.para[,1]/b.para[,2], 2*(1-pt(abs(Tval), summary(fit)$df)))
    anames = paste("Age ", as.character(age))
    pnames = paste("Period ", as.character(period))
    cnames = paste("Cohort ", as.character(cohort))
    dimnames(b.para.full)[[1]] = c("intercept", anames, pnames, cnames)
    dimnames(b.para.full)[[2]] = c("Parameter","Standard.Error", "t", "P-value")
  }
  ##########################################################
  #### Model fitting ### Constraint estimator ############## 
  if (apc>0) 
  {
    xc <- constr(x[,-1], a, p, c1, c2, cc, apc)   
    fit <- lm(y ~ xc)
    sol$inter <- fit$coef[1]
    if(apc == 1) {
      aa <- fit$coef[2:(a - 1)]
      aa <- c(aa[1:(c2 - 1)], cc * aa[c1], aa[-1: - (c2 - 1)])
      pp <- fit$coef[a:(a + p - 2)]
      coh <- fit$coef[-1:-(a+p-2)]   
    }
    if(apc == 2) {
      aa <- fit$coef[2:a]
      pp <- fit$coef[(a + 1):(a + p - 2)]
      pp <- c(pp[1:(c2 - 1)], cc * pp[c1], pp[-1: - (c2 - 1)])
      coh <- fit$coef[-1:-(a+p-2)]   
    }
    if(apc == 3) {
      aa <- fit$coef[2:a]
      pp <- fit$coef[(a + 1):(a + p - 1)]
      coh <- fit$coef[(a + p):length(fit$coef)]
      coh <- c(coh[1:(c2 - 1)], cc * coh[c1], coh[-1: - (c2 - 1)])
    }
  }
  ##########################################################
  ####  plot of age period cohort trend #############
  
  if (CIplot == T) {
    alim = range(b.para[1:a+1,1] + 1.96*b.para[1:a+1,2], b.para[1:a+1,1] - 1.96*b.para[1:a+1,2])
    plim = range(b.para[1:p+a+1,1] + 1.96*b.para[1:p+a+1,2], b.para[1:p+a+1,1] - 1.96*b.para[1:p+a+1,2])
    clim = range(b.para[-1:-(a+p+1),1] + 1.96*b.para[-1:-(a+p+1),2], b.para[-1:-(a+p+1),1] - 1.96*b.para[-1:-(a+p+1),2])
  }
  if (CIplot == F) {
    alim = range(b.para[1:a+1,1])
    plim = range(b.para[1:p+a+1,1])
    clim = range(b.para[-1:-(a+p+1),1] )
  }
  if (sum(abs(pplim)) > 0) {
    alim = plim = clim = pplim
  }
  if (panelplot == T)
    par(mfrow=c(2,2))

###################################################################################
################## age trend ##############  
  if (Plot == T) {
    plot(age, c(aa,-sum(aa)), ylab="effect", type='l', ylim=alim)
    points(age, c(aa,-sum(aa)))
    title (main="Age effect")
    
    if (CIplot == T) {
      lines(age, b.para[1:a+1,1] - 1.96*b.para[1:a+1,2], lty = 2)
      lines(age, b.para[1:a+1,1] + 1.96*b.para[1:a+1,2], lty = 2)
    }
      
###################################################################################
################## Period trend ##############  
    
    plot(period, c(pp,-sum(pp)), ylab="effect", type='l', ylim=plim)
    points(period, c(pp,-sum(pp)))
    title (main="Period effect")
    
    if (CIplot == T) {
      lines (period, b.para[1:p+a+1,1] - 1.96*b.para[1:p+a+1,2], lty = 2)
      lines (period, b.para[1:p+a+1,1] + 1.96*b.para[1:p+a+1,2], lty = 2)
    }
 
###################################################################################
################## Cohort trend ##############  

  if (panelplot == T) 
    par(mfrow=c(2,1), new = T, fig = c(0, 1, 0, 0.56), cex=0.85)
    
    plot(cohort, c(coh,-sum(coh)), ylab="effect", type='l', ylim=clim)
    points(cohort, c(coh,-sum(coh)))
    title (main="Cohort effect")
    
    if (CIplot == T) {
      lines (cohort, b.para[-1:-(p+a+1),1] - 1.96*b.para[-1:-(p+a+1),2], lty = 2)
      lines (cohort, b.para[-1:-(p+a+1),1] + 1.96*b.para[-1:-(p+a+1),2], lty = 2)
    }
  par(mfrow=c(1,1))
  }

  ##########################################################
  #### Model diagnostic check by residual plot #############
  
  if(ModelDiag == T) {
    plot(fit$fitted, fit$residual, xlab="fitted value", ylab="residual")
    abline(a=0,b=0, col=2)
    title(main="Residual plot for linear model diagnostics")
    if ( var(Diaglim) > 0) {
      abline(a=Diaglim[1], b=0, lty=2, col=4)
      abline(a=Diaglim[2], b=0, lty=2, col=4)
#  browser()    
      obs.id = c((1:length(y))[fit$resid>=max(Diaglim)], (1:length(y))[fit$resid<= min(Diaglim)])
      n.obs.id = length(obs.id)
      outlier.obs = matrix(NA, n.obs.id, 4)
      for (i in 1:n.obs.id) {
        outlier.obs [i,1] = fit$resid[obs.id[i]]
        outlier.obs [i,2] = y[obs.id[i]]
        outlier.obs [i,3] = 1+floor((obs.id[i]-1)/p)
        outlier.obs [i,4] = obs.id[i] - p*floor(obs.id[i]/p) 
        if (outlier.obs[i,4] == 0)
          outlier.obs[i,4] = p
      }
    }
  }
  Rsquare = c(summary(fit)$r.squared, summary(fit)$adj.r.squared, ncol(v)-1)
  names(Rsquare) = c("Rsquare", "Adjusted.Rsquare", "Model df")
  Varcomp = c(summary(fit)$sig, summary(fit)$df[2])
  names(Varcomp) = c("Variance Component", "Residual df")
  
  sol <- vector("list") 
  sol$model = fit$call
  sol$scale = transform
  sol$Rsquare = Rsquare 
  sol$varcomp_df = Varcomp
  sol$parameters = b.para.full
  
  if (ModelDiag == T && var(Diaglim) > 0)
    sol$outlier = outlier.obs
  
    return(sol)
}
