constr <-
function(nr, nc, c1, c2, cc, apc = 1, lindex=0, lvalue=0, ref=c(0,0,0) ) {
# APC = 1, age; = 2, period; =3, cohort.
# c1, c2: the column numbers of constrait.
# cc : the coef for the constraint, Beta2 = cc * Beta1.
# Ref[1] = 0: centralization on age; ref[1] > 1: set ref[1] as reference age level and drop that column.
# Ref[2] = 0: centralization on period; ref[2] > 1: set ref[2] as reference period level and drop that column.
# Ref[3] = 0: centralization on cohort; ref[3] > 1: set ref[3] as reference cohort level and drop that column.
  
x = apcmat(a=nr, p=nc, ref=ref)

if (sum(ref) == 0 ) { 
if (length(lindex)==1 || length(lvalue)==1) {
	if(apc == 1) {
		cc1 <- min(c1, c2) + 1
		cc2 <- max(c1, c2) + 1
	}
	if(apc == 2) {
		cc1 <- min(c1, c2) + nr
		cc2 <- max(c1, c2) + nr
	}
	if(apc == 3) {
		cc1 <- min(c1, c2) + nr + nc - 1
		cc2 <- max(c1, c2) + nr + nc - 1
	}
	c1 <- cc1
	c2 <- cc2
	if(c2 - c1 == 1) {
		xc <- cbind(x[, 1:(c1 - 1)], x[, c1] + cc * x[, c2], x[, c(-1: -c2)])
	}
	if(c2 - c1 > 1) {
		xc <- cbind(x[, 1:(c1 - 1)], x[, c1] + cc * x[, c2], x[, (c1 + 1):
			(c2 - 1)], x[, -1: - c2])
	}
	if(c1 == c2) {
		xc <- x
	}
	xc
 }
else 
	{	if ( !(length(lindex) == length(lvalue)) ) 
			stop(paste("Wrong constraint: lengths of index and value need to be equal"))
		else
		  {	##### need to remove 0, sort the constraint index and the value
			lzero = (abs(lvalue)< 1e-12)
			if (sum(lzero) == 0 )
				lzero = NULL
			else {
				lvalue = lvalue [-lzero]
				lindex = lindex [-lzero]
				lzero = NULL	
				if (  !(length(lindex) == 0) ) 
					stop(paste("Wrong constraint: need to specify at least one nonzero  index"))
			 }
			
			lorder = order(lindex)
			lindex = lindex[lorder]
			lvalue = lvalue[lorder]
			nindex= length(lindex)
			indexlast = lindex[nindex]
			valuelast = lvalue[nindex]

			### apply constraint to APC matrix (including intercept)
			x = apcmat(nr, nc, ref=ref)
			
			###### special case: only one nonzero index then it must be zero
			if (nindex == 1) {
			    if (apc == 1)
				xc = x[,-(1+indexlast)]
			    if (apc == 2)
				xc = x[,-(nr + indexlast)]
			    if (apc == 3)
				xc = x[,-(nr + np -1 + indexlast)]
			  }
			else  {
			    if (apc == 1) {
				xc = x[,-(1+indexlast)]
				xc [(1:nc)+nc*(indexlast-1),1+lindex[-nindex]] = outer(rep(1, nc),-lvalue[-nindex] /valuelast)

				## last row need adjustment (alpha_a = -[alpha_1+...+alpha_(a-1)] )
				xc [(1:nc)+nc*(nr-1),1+lindex[-nindex]] = xc [(1:nc)+nc*(nr-1),1+lindex[-nindex]] +
					outer(rep(1,nc), lvalue[-nindex]/valuelast)
				}

			    if (apc == 2) {
				xc = x[,-(nr + indexlast)]		
				xc [(1:nr-1)*nc+indexlast,nr+lindex[-nindex]] = outer(rep(1 ,nr ), -lvalue[-nindex]/valuelast)
				xc [(1:nr)*nc, nr+lindex[-nindex] ] = xc [(1:nr)*nc, nr+lindex[-nindex] ] + 
					outer(rep(1,nr),lvalue[-nindex]/valuelast)
				}

			    if (apc == 3) {
				xc = x[,-(nr + nc -1 + indexlast)] 
				
				#### consider separately indexlast <= nr or indexlast > nr
				#### first need to determine the cells on the last diagonal, then adjust xc.

				if (indexlast <= nr) {	### start last index diag with cell (a-k+1, 1) to (a-k,2),..., 
					lastdiag.row = c( (nr-indexlast+1):nr )
					lastdiag.col = c( 1:nc )
					lastdiag.len = min(length(lastdiag.row), length(lastdiag.col))
					lastdiag.r = lastdiag.row[1:lastdiag.len]
					lastdiag.c = lastdiag.col[1:lastdiag.len]
				 }
				else {				### start last diag with cell (1, k-a+1)
					lastdiag.col = c( (indexlast-nr+1):nc )
					lastdiag.row = c( 1:nr )
					lastdiag.len = min(length(lastdiag.row), length(lastdiag.col))
					lastdiag.r = lastdiag.row[1:lastdiag.len]
					lastdiag.c = lastdiag.col[1:lastdiag.len]
				 }

				#### use the above lastdiag coordinate to update the last diagonal for covariates
				xc [ ((lastdiag.r[1]-1)*nc+lastdiag.c[1])+(nc+1)*(0:(lastdiag.len-1)),   nr + nc - 1 + lindex[-nindex] ] = 
					outer(rep(1 ,lastdiag.len), -lvalue[-nindex]/valuelast)
				xc [nc , nr + nc-1 + lindex[-nindex] ] = xc [nc , nr + nc-1 + lindex[-nindex] ] +
					lvalue[-nindex]/valuelast
				}
			 }
		 }
	}
} ###### Finishing ref = 0, some var is dropped as ref.

 if (sum(ref) > 0) {
   stop(paste("constraint for reference var is not stable. do not specify it. Use constraint for centralization."))
   x = apcmat(a=nr, p=nc, ref=ref)
   if ( ref[1] > 0 )
      x = x[,-(ref[1]+1)]
   if ( ref[2] > 0 )
      x = x[,-(a+ref[2])]
   if ( ref[3] > 0 )
      x = x[,-(a+p-1+ref[3])]
   ##################################### add constraint part here ###############################
   
   xc = x
 }

return(xc)
}
