\name{APCG_data}
\alias{APCG_data}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Some Data Sets used in the Book: A Practical Guide to APC Analysis.
}
\description{
Generate 4 data sets used in the APC Guide book (Fu 2018), separately by specifying the names of the data set, "lungCAmale", "lungCAfemale", "HIV", and "Retire".}
\usage{
APCG_data(apcdata = "Retire", header = F)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{apcdata}{
a character string of the name of data set to generate, "Retire", "HIV", "lungCAmale", or "lungCAfemale".
}
  \item{header}{
logic value, if TRUE, a header of the data set will be generated as well.
}
}
\details{
Except for the US retirement account median value data set ("retire"), the other three data sets have 3 subsets, the rate, frequency, and population data subsets. All 3 datasets are originally generated by 
the SEER*Stat software of the SEER cancer registry database. The rate of 0 in cell (age=20, period=1995)
of the US Lung Cancer data USlungCAfemale.r is due to the supression of small counts by the SEER*Stat.
}
\value{
%%  ~Describe the value returned
%%  If it is a LIST, use
  \item{med.value}{if apcdata="retire", provide a matrix of median retirement account value.}
  \item{rate}{if apcdata!="retire". The mortality rate per 100,000 population.}
  \item{frequency}{if apcdata!="retire". The number of deaths of specific age group in specific years.}
  \item{population}{if apcdata!="retire". The total number of people in the US of specified sex (including healthy people) of specific age group in specific years.}
%% ...
}
\references{
Fu, W (2018) A Practical Guide to Age-period-cohort Analysis --- the Identification Problem and Beyond, CRC.
}
\author{
Wenjiang Fu
}
\note{
A data header is provided only to the median value or rate matrix, if header = True is specified. It provides age group and year information of the data. 
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

%\seealso{
%% ~~objects to See Also as \code{\link{help}}, ~~~
%}
\examples{
x=APCG_data(apcdata = "retire", header=TRUE)$med.value
x
x=APCG_data(apcdata = "hiv", header=TRUE)
x$rate
x$population
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ datagen }% use one of  RShowDoc("KEYWORDS")
%%\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line
