\name{apcheader}
\alias{apcheader}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Add Header to APC Data Matrix.
}
\description{
Add group labels to each row and column of APC data matrix, so that in data plot and the output 
of model parameter estimates, labels will be automatically calculated and used.
}
\usage{
apcheader(r, header = F, agestart = 1, yearstart = 1, agespan = 1, yearspan = 1)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{r}{
  matrix of APC data with a rows and p columns, 
}
  \item{header}{
  logic value. "False" prompts to add header to the data; "True" makes no change. 
}
  \item{agestart, yearstart}{
  starting value of age and period groups.
}
  \item{agespan, yearspan}{spans or number of years in each group of age and period.
}
}
\details{
Add a header to apc data matrix and label of the effects in the plot or model fitting output. 
without header, the group labels are group number: 1, 2, 3, ... for the age, period, and cohort effects. 
}
\value{A matrix of the input APC data matrix with group labels in dimension names.  
}
\references{
Fu, W. (2018) A Practical Guide to Age-Period-Cohort Analysis - the Identification Problem and Beyond, CRC. 
}
\author{
Wenjiang Fu
}
\note{
A matrix with rows as age groups and columns as periods is preferred. 
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
apcplot, apclinfit, apcglmfit %% ~~objects to See Also as \code{\link{help}}, ~~~
}
\examples{
r = matrix(c(1:40), ncol=8, byr=TRUE) 
r = apcheader(r, agestart=20, yearstart=1980, agespan=10, yearspan=5)
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ array }% use one of  RShowDoc("KEYWORDS")
%\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line
